--- Mesa-7.8.2/src/mesa/glapi/gen/gl_x86-64_asm.py.orig	2010-06-16 03:43:43.000000000 +1000
+++ Mesa-7.8.2/src/mesa/glapi/gen/gl_x86-64_asm.py	2010-12-06 15:23:06.000000000 +1100
@@ -53,7 +53,7 @@
 	adjust_stack = 0
 	if not should_use_push(registers):
 		adjust_stack = local_size(registers)
-		print '\tsubq\t$%u, %%rsp' % (adjust_stack)
+		print ('\tsubq\t$%u, %%rsp' % (adjust_stack))
 
 	for [reg, stack_offset] in registers:
 		save_reg( reg, stack_offset, adjust_stack )
@@ -71,18 +71,18 @@
 		restore_reg(reg, stack_offset, adjust_stack)
 
 	if adjust_stack:
-		print '\taddq\t$%u, %%rsp' % (adjust_stack)
+		print ('\taddq\t$%u, %%rsp' % (adjust_stack))
 	return
 
 
 def save_reg(reg, offset, use_move):
 	if use_move:
 		if offset == 0:
-			print '\tmovq\t%s, (%%rsp)' % (reg)
+			print ('\tmovq\t%s, (%%rsp)' % (reg))
 		else:
-			print '\tmovq\t%s, %u(%%rsp)' % (reg, offset)
+			print ('\tmovq\t%s, %u(%%rsp)' % (reg, offset))
 	else:
-		print '\tpushq\t%s' % (reg)
+		print ('\tpushq\t%s' % (reg))
 
 	return
 
@@ -90,11 +90,11 @@
 def restore_reg(reg, offset, use_move):
 	if use_move:
 		if offset == 0:
-			print '\tmovq\t(%%rsp), %s' % (reg)
+			print ('\tmovq\t(%%rsp), %s' % (reg))
 		else:
-			print '\tmovq\t%u(%%rsp), %s' % (offset, reg)
+			print ('\tmovq\t%u(%%rsp), %s' % (offset, reg))
 	else:
-		print '\tpopq\t%s' % (reg)
+		print ('\tpopq\t%s' % (reg))
 
 	return
 
@@ -118,84 +118,84 @@
 
 
 	def printRealHeader(self):
-		print "/* If we build with gcc's -fvisibility=hidden flag, we'll need to change"
-		print " * the symbol visibility mode to 'default'."
-		print ' */'
-		print ''
-		print '#include "x86/assyntax.h"'
-		print ''
-		print '#ifdef __GNUC__'
-		print '#  pragma GCC visibility push(default)'
-		print '#  define HIDDEN(x) .hidden x'
-		print '#else'
-		print '#  define HIDDEN(x)'
-		print '#endif'
-		print ''
-		print '# if defined(USE_MGL_NAMESPACE)'
-		print '#  define GL_PREFIX(n) GLNAME(CONCAT(mgl,n))'
-		print '#  define _glapi_Dispatch _mglapi_Dispatch'
-		print '# else'
-		print '#  define GL_PREFIX(n) GLNAME(CONCAT(gl,n))'
-		print '# endif'
-		print ''
-		print '#if defined(PTHREADS) || defined(WIN32_THREADS) || defined(BEOS_THREADS)'
-		print '#  define THREADS'
-		print '#endif'
-		print ''
-		print '\t.text'
-		print ''
-		print '#ifdef GLX_USE_TLS'
-		print ''
-		print '\t.globl _x86_64_get_get_dispatch; HIDDEN(_x86_64_get_get_dispatch)'
-		print '_x86_64_get_get_dispatch:'
-		print '\tlea\t_x86_64_get_dispatch(%rip), %rax'
-		print '\tret'
-		print ''
-		print '\t.p2align\t4,,15'
-		print '_x86_64_get_dispatch:'
-		print '\tmovq\t_glapi_tls_Dispatch@GOTTPOFF(%rip), %rax'
-		print '\tmovq\t%fs:(%rax), %rax'
-		print '\tret'
-		print '\t.size\t_x86_64_get_dispatch, .-_x86_64_get_dispatch'
-		print ''
-		print '#elif defined(PTHREADS)'
-		print ''
-		print '\t.extern\t_glapi_Dispatch'
-		print '\t.extern\t_gl_DispatchTSD'
-		print '\t.extern\tpthread_getspecific'
-		print ''
-		print '\t.p2align\t4,,15'
-		print '_x86_64_get_dispatch:'
-		print '\tmovq\t_gl_DispatchTSD(%rip), %rdi'
-		print '\tjmp\tpthread_getspecific@PLT'
-		print ''
-		print '#elif defined(THREADS)'
-		print ''
-		print '\t.extern\t_glapi_get_dispatch'
-		print ''
-		print '#endif'
-		print ''
+		print ("/* If we build with gcc's -fvisibility=hidden flag, we'll need to change")
+		print (" * the symbol visibility mode to 'default'.")
+		print (' */')
+		print ('')
+		print ('#include "x86/assyntax.h"')
+		print ('')
+		print ('#ifdef __GNUC__')
+		print ('#  pragma GCC visibility push(default)')
+		print ('#  define HIDDEN(x) .hidden x')
+		print ('#else')
+		print ('#  define HIDDEN(x)')
+		print ('#endif')
+		print ('')
+		print ('# if defined(USE_MGL_NAMESPACE)')
+		print ('#  define GL_PREFIX(n) GLNAME(CONCAT(mgl,n))')
+		print ('#  define _glapi_Dispatch _mglapi_Dispatch')
+		print ('# else')
+		print ('#  define GL_PREFIX(n) GLNAME(CONCAT(gl,n))')
+		print ('# endif')
+		print ('')
+		print ('#if defined(PTHREADS) || defined(WIN32_THREADS) || defined(BEOS_THREADS)')
+		print ('#  define THREADS')
+		print ('#endif')
+		print ('')
+		print ('\t.text')
+		print ('')
+		print ('#ifdef GLX_USE_TLS')
+		print ('')
+		print ('\t.globl _x86_64_get_get_dispatch; HIDDEN(_x86_64_get_get_dispatch)')
+		print ('_x86_64_get_get_dispatch:')
+		print ('\tlea\t_x86_64_get_dispatch(%rip), %rax')
+		print ('\tret')
+		print ('')
+		print ('\t.p2align\t4,,15')
+		print ('_x86_64_get_dispatch:')
+		print ('\tmovq\t_glapi_tls_Dispatch@GOTTPOFF(%rip), %rax')
+		print ('\tmovq\t%fs:(%rax), %rax')
+		print ('\tret')
+		print ('\t.size\t_x86_64_get_dispatch, .-_x86_64_get_dispatch')
+		print ('')
+		print ('#elif defined(PTHREADS)')
+		print ('')
+		print ('\t.extern\t_glapi_Dispatch')
+		print ('\t.extern\t_gl_DispatchTSD')
+		print ('\t.extern\tpthread_getspecific')
+		print ('')
+		print ('\t.p2align\t4,,15')
+		print ('_x86_64_get_dispatch:')
+		print ('\tmovq\t_gl_DispatchTSD(%rip), %rdi')
+		print ('\tjmp\tpthread_getspecific@PLT')
+		print ('')
+		print ('#elif defined(THREADS)')
+		print ('')
+		print ('\t.extern\t_glapi_get_dispatch')
+		print ('')
+		print ('#endif')
+		print ('')
 		return
 
 
 	def printRealFooter(self):
-		print ''
-		print '#if defined(GLX_USE_TLS) && defined(__linux__)'
-		print '	.section ".note.ABI-tag", "a"'
-		print '	.p2align 2'
-		print '	.long	1f - 0f   /* name length */'
-		print '	.long	3f - 2f   /* data length */'
-		print '	.long	1         /* note length */'
-		print '0:	.asciz "GNU"      /* vendor name */'
-		print '1:	.p2align 2'
-		print '2:	.long	0         /* note data: the ABI tag */'
-		print '	.long	2,4,20    /* Minimum kernel version w/TLS */'
-		print '3:	.p2align 2        /* pad out section */'
-		print '#endif /* GLX_USE_TLS */'
-		print ''
-		print '#if defined (__ELF__) && defined (__linux__)'
-		print '	.section .note.GNU-stack,"",%progbits'
-		print '#endif'
+		print ('')
+		print ('#if defined(GLX_USE_TLS) && defined(__linux__)')
+		print ('	.section ".note.ABI-tag", "a"')
+		print ('	.p2align 2')
+		print ('	.long	1f - 0f   /* name length */')
+		print ('	.long	3f - 2f   /* data length */')
+		print ('	.long	1         /* note length */')
+		print ('0:	.asciz "GNU"      /* vendor name */')
+		print ('1:	.p2align 2')
+		print ('2:	.long	0         /* note data: the ABI tag */')
+		print ('	.long	2,4,20    /* Minimum kernel version w/TLS */')
+		print ('3:	.p2align 2        /* pad out section */')
+		print ('#endif /* GLX_USE_TLS */')
+		print ('')
+		print ('#if defined (__ELF__) && defined (__linux__)')
+		print ('	.section .note.GNU-stack,"",%progbits')
+		print ('#endif')
 		return
 
 
@@ -240,47 +240,47 @@
 
 		name = f.dispatch_name()
 
-		print '\t.p2align\t4,,15'
-		print '\t.globl\tGL_PREFIX(%s)' % (name)
-		print '\t.type\tGL_PREFIX(%s), @function' % (name)
+		print ('\t.p2align\t4,,15')
+		print ('\t.globl\tGL_PREFIX(%s)' % (name))
+		print ('\t.type\tGL_PREFIX(%s), @function' % (name))
 		if not f.is_static_entry_point(f.name):
-			print '\tHIDDEN(GL_PREFIX(%s))' % (name)
-		print 'GL_PREFIX(%s):' % (name)
-		print '#if defined(GLX_USE_TLS)'
-		print '\tcall\t_x86_64_get_dispatch@PLT'
-		print '\tmovq\t%u(%%rax), %%r11' % (f.offset * 8)
-		print '\tjmp\t*%r11'
-		print '#elif defined(PTHREADS)'
+			print ('\tHIDDEN(GL_PREFIX(%s))' % (name))
+		print ('GL_PREFIX(%s):' % (name))
+		print ('#if defined(GLX_USE_TLS)')
+		print ('\tcall\t_x86_64_get_dispatch@PLT')
+		print ('\tmovq\t%u(%%rax), %%r11' % (f.offset * 8))
+		print ('\tjmp\t*%r11')
+		print ('#elif defined(PTHREADS)')
 		
 		save_all_regs(registers)
-		print '\tcall\t_x86_64_get_dispatch@PLT'
+		print ('\tcall\t_x86_64_get_dispatch@PLT')
 		restore_all_regs(registers)
 
 		if f.offset == 0:
-			print '\tmovq\t(%rax), %r11'
+			print ('\tmovq\t(%rax), %r11')
 		else:
-			print '\tmovq\t%u(%%rax), %%r11' % (f.offset * 8)
+			print ('\tmovq\t%u(%%rax), %%r11' % (f.offset * 8))
 
-		print '\tjmp\t*%r11'
+		print ('\tjmp\t*%r11')
 
-		print '#else'
-		print '\tmovq\t_glapi_Dispatch(%rip), %rax'
-		print '\ttestq\t%rax, %rax'
-		print '\tje\t1f'
-		print '\tmovq\t%u(%%rax), %%r11' % (f.offset * 8)
-		print '\tjmp\t*%r11'
-		print '1:'
+		print ('#else')
+		print ('\tmovq\t_glapi_Dispatch(%rip), %rax')
+		print ('\ttestq\t%rax, %rax')
+		print ('\tje\t1f')
+		print ('\tmovq\t%u(%%rax), %%r11' % (f.offset * 8))
+		print ('\tjmp\t*%r11')
+		print ('1:')
 
 		save_all_regs(registers)
-		print '\tcall\t_glapi_get_dispatch'
+		print ('\tcall\t_glapi_get_dispatch')
 		restore_all_regs(registers)
 
-		print '\tmovq\t%u(%%rax), %%r11' % (f.offset * 8)
-		print '\tjmp\t*%r11'
-		print '#endif /* defined(GLX_USE_TLS) */'
+		print ('\tmovq\t%u(%%rax), %%r11' % (f.offset * 8))
+		print ('\tjmp\t*%r11')
+		print ('#endif /* defined(GLX_USE_TLS) */')
 
-		print '\t.size\tGL_PREFIX(%s), .-GL_PREFIX(%s)' % (name, name)
-		print ''
+		print ('\t.size\tGL_PREFIX(%s), .-GL_PREFIX(%s)' % (name, name))
+		print ('')
 		return
 
 
@@ -297,16 +297,16 @@
 						text = '\t.globl GL_PREFIX(%s) ; .set GL_PREFIX(%s), GL_PREFIX(%s)' % (n, n, dispatch)
 
 						if f.has_different_protocol(n):
-							print '#ifndef GLX_INDIRECT_RENDERING'
-							print text
-							print '#endif'
+							print ('#ifndef GLX_INDIRECT_RENDERING')
+							print (text)
+							print ('#endif')
 						else:
-							print text
+							print (text)
 
 		return
 
 def show_usage():
-	print "Usage: %s [-f input_file_name] [-m output_mode]" % sys.argv[0]
+	print ("Usage: %s [-f input_file_name] [-m output_mode]" % sys.argv[0])
 	sys.exit(1)
 
 if __name__ == '__main__':
@@ -327,7 +327,7 @@
 	if mode == "generic":
 		printer = PrintGenericStubs()
 	else:
-		print "ERROR: Invalid mode \"%s\" specified." % mode
+		print ("ERROR: Invalid mode \"%s\" specified." % mode)
 		show_usage()
 
 	api = gl_XML.parse_GL_API(file_name, glX_XML.glx_item_factory())
--- Mesa-7.8.2/src/mesa/glapi/gen/gl_x86_asm.py.orig	2010-06-16 03:43:43.000000000 +1000
+++ Mesa-7.8.2/src/mesa/glapi/gen/gl_x86_asm.py	2010-12-06 15:22:28.000000000 +1100
@@ -53,159 +53,159 @@
 
 
 	def printRealHeader(self):
-		print '#include "x86/assyntax.h"'
-		print '#include "glapi/glapioffsets.h"'
-		print ''
-		print '#if defined(STDCALL_API)'
-		print '# if defined(USE_MGL_NAMESPACE)'
-		print '#  define GL_PREFIX(n,n2) GLNAME(CONCAT(mgl,n2))'
-		print '# else'
-		print '#  define GL_PREFIX(n,n2) GLNAME(CONCAT(gl,n2))'
-		print '# endif'
-		print '#else'
-		print '# if defined(USE_MGL_NAMESPACE)'
-		print '#  define GL_PREFIX(n,n2) GLNAME(CONCAT(mgl,n))'
-		print '#  define _glapi_Dispatch _mglapi_Dispatch'
-		print '# else'
-		print '#  define GL_PREFIX(n,n2) GLNAME(CONCAT(gl,n))'
-		print '# endif'
-		print '#endif'
-		print ''
-		print '#define GL_OFFSET(x) CODEPTR(REGOFF(4 * x, EAX))'
-		print ''
-		print '#if defined(GNU_ASSEMBLER) && !defined(__DJGPP__) && !defined(__MINGW32__) && !defined(__APPLE__)'
-		print '#define GLOBL_FN(x) GLOBL x ; .type x, function'
-		print '#else'
-		print '#define GLOBL_FN(x) GLOBL x'
-		print '#endif'
-		print ''
-		print '#if defined(PTHREADS) || defined(WIN32_THREADS) || defined(BEOS_THREADS)'
-		print '#  define THREADS'
-		print '#endif'
-		print ''
-		print '#ifdef GLX_USE_TLS'
-		print ''
-		print '#ifdef GLX_X86_READONLY_TEXT'
-		print '# define CTX_INSNS MOV_L(GS:(EAX), EAX)'
-		print '#else'
-		print '# define CTX_INSNS NOP /* Pad for init_glapi_relocs() */'
-		print '#endif'
-		print ''
-		print '#  define GL_STUB(fn,off,fn_alt)\t\t\t\\'
-		print 'ALIGNTEXT16;\t\t\t\t\t\t\\'
-		print 'GLOBL_FN(GL_PREFIX(fn, fn_alt));\t\t\t\\'
-		print 'GL_PREFIX(fn, fn_alt):\t\t\t\t\t\\'
-		print '\tCALL(_x86_get_dispatch) ;\t\t\t\\'
-		print '\tCTX_INSNS ;					\\'
-		print '\tJMP(GL_OFFSET(off))'
-		print ''
-		print '#elif defined(PTHREADS)'
-		print '#  define GL_STUB(fn,off,fn_alt)\t\t\t\\'
-		print 'ALIGNTEXT16;\t\t\t\t\t\t\\'
-		print 'GLOBL_FN(GL_PREFIX(fn, fn_alt));\t\t\t\\'
-		print 'GL_PREFIX(fn, fn_alt):\t\t\t\t\t\\'
-		print '\tMOV_L(CONTENT(GLNAME(_glapi_Dispatch)), EAX) ;\t\\'
-		print '\tTEST_L(EAX, EAX) ;\t\t\t\t\\'
-		print '\tJE(1f) ;\t\t\t\t\t\\'
-		print '\tJMP(GL_OFFSET(off)) ;\t\t\t\t\\'
-		print '1:\tCALL(_x86_get_dispatch) ;\t\t\t\\'
-		print '\tJMP(GL_OFFSET(off))'
-		print '#elif defined(THREADS)'
-		print '#  define GL_STUB(fn,off,fn_alt)\t\t\t\\'
-		print 'ALIGNTEXT16;\t\t\t\t\t\t\\'
-		print 'GLOBL_FN(GL_PREFIX(fn, fn_alt));\t\t\t\\'
-		print 'GL_PREFIX(fn, fn_alt):\t\t\t\t\t\\'
-		print '\tMOV_L(CONTENT(GLNAME(_glapi_Dispatch)), EAX) ;\t\\'
-		print '\tTEST_L(EAX, EAX) ;\t\t\t\t\\'
-		print '\tJE(1f) ;\t\t\t\t\t\\'
-		print '\tJMP(GL_OFFSET(off)) ;\t\t\t\t\\'
-		print '1:\tCALL(_glapi_get_dispatch) ;\t\t\t\\'
-		print '\tJMP(GL_OFFSET(off))'
-		print '#else /* Non-threaded version. */'
-		print '#  define GL_STUB(fn,off,fn_alt)\t\t\t\\'
-		print 'ALIGNTEXT16;\t\t\t\t\t\t\\'
-		print 'GLOBL_FN(GL_PREFIX(fn, fn_alt));\t\t\t\\'
-		print 'GL_PREFIX(fn, fn_alt):\t\t\t\t\t\\'
-		print '\tMOV_L(CONTENT(GLNAME(_glapi_Dispatch)), EAX) ;\t\\'
-		print '\tJMP(GL_OFFSET(off))'
-		print '#endif'
-		print ''
-		print '#ifdef HAVE_ALIAS'
-		print '#  define GL_STUB_ALIAS(fn,off,fn_alt,alias,alias_alt)\t\\'
-		print '\t.globl\tGL_PREFIX(fn, fn_alt) ;\t\t\t\\'
-		print '\t.set\tGL_PREFIX(fn, fn_alt), GL_PREFIX(alias, alias_alt)'
-		print '#else'
-		print '#  define GL_STUB_ALIAS(fn,off,fn_alt,alias,alias_alt)\t\\'
-		print '    GL_STUB(fn, off, fn_alt)'
-		print '#endif'
-		print ''
-		print 'SEG_TEXT'
-		print ''
-		print '#ifdef GLX_USE_TLS'
-		print ''
-		print '\tGLOBL\tGLNAME(_x86_get_dispatch)'
-		print '\tHIDDEN(GLNAME(_x86_get_dispatch))'
-		print 'ALIGNTEXT16'
-		print 'GLNAME(_x86_get_dispatch):'
-		print '\tcall	1f'
-		print '1:\tpopl	%eax'
-		print '\taddl	$_GLOBAL_OFFSET_TABLE_+[.-1b], %eax'
-		print '\tmovl	_glapi_tls_Dispatch@GOTNTPOFF(%eax), %eax'
-		print '\tret'
-		print ''
-		print '#elif defined(PTHREADS)'
-		print 'EXTERN GLNAME(_glapi_Dispatch)'
-		print 'EXTERN GLNAME(_gl_DispatchTSD)'
-		print 'EXTERN GLNAME(pthread_getspecific)'
-		print ''
-		print 'ALIGNTEXT16'
-		print 'GLNAME(_x86_get_dispatch):'
-		print '\tSUB_L(CONST(24), ESP)'
-		print '\tPUSH_L(GLNAME(_gl_DispatchTSD))'
-		print '\tCALL(GLNAME(pthread_getspecific))'
-		print '\tADD_L(CONST(28), ESP)'
-		print '\tRET'
-		print '#elif defined(THREADS)'
-		print 'EXTERN GLNAME(_glapi_get_dispatch)'
-		print '#endif'
-		print ''
-
-		print '#if defined( GLX_USE_TLS ) && !defined( GLX_X86_READONLY_TEXT )'
-		print '\t\t.section\twtext, "awx", @progbits'
-		print '#endif /* defined( GLX_USE_TLS ) */'
-
-		print ''
-		print '\t\tALIGNTEXT16'
-		print '\t\tGLOBL GLNAME(gl_dispatch_functions_start)'
-		print '\t\tHIDDEN(GLNAME(gl_dispatch_functions_start))'
-		print 'GLNAME(gl_dispatch_functions_start):'
-		print ''
+		print ('#include "x86/assyntax.h"')
+		print ('#include "glapi/glapioffsets.h"')
+		print ('')
+		print ('#if defined(STDCALL_API)')
+		print ('# if defined(USE_MGL_NAMESPACE)')
+		print ('#  define GL_PREFIX(n,n2) GLNAME(CONCAT(mgl,n2))')
+		print ('# else')
+		print ('#  define GL_PREFIX(n,n2) GLNAME(CONCAT(gl,n2))')
+		print ('# endif')
+		print ('#else')
+		print ('# if defined(USE_MGL_NAMESPACE)')
+		print ('#  define GL_PREFIX(n,n2) GLNAME(CONCAT(mgl,n))')
+		print ('#  define _glapi_Dispatch _mglapi_Dispatch')
+		print ('# else')
+		print ('#  define GL_PREFIX(n,n2) GLNAME(CONCAT(gl,n))')
+		print ('# endif')
+		print ('#endif')
+		print ('')
+		print ('#define GL_OFFSET(x) CODEPTR(REGOFF(4 * x, EAX))')
+		print ('')
+		print ('#if defined(GNU_ASSEMBLER) && !defined(__DJGPP__) && !defined(__MINGW32__) && !defined(__APPLE__)')
+		print ('#define GLOBL_FN(x) GLOBL x ; .type x, function')
+		print ('#else')
+		print ('#define GLOBL_FN(x) GLOBL x')
+		print ('#endif')
+		print ('')
+		print ('#if defined(PTHREADS) || defined(WIN32_THREADS) || defined(BEOS_THREADS)')
+		print ('#  define THREADS')
+		print ('#endif')
+		print ('')
+		print ('#ifdef GLX_USE_TLS')
+		print ('')
+		print ('#ifdef GLX_X86_READONLY_TEXT')
+		print ('# define CTX_INSNS MOV_L(GS:(EAX), EAX)')
+		print ('#else')
+		print ('# define CTX_INSNS NOP /* Pad for init_glapi_relocs() */')
+		print ('#endif')
+		print ('')
+		print ('#  define GL_STUB(fn,off,fn_alt)\t\t\t\\')
+		print ('ALIGNTEXT16;\t\t\t\t\t\t\\')
+		print ('GLOBL_FN(GL_PREFIX(fn, fn_alt));\t\t\t\\')
+		print ('GL_PREFIX(fn, fn_alt):\t\t\t\t\t\\')
+		print ('\tCALL(_x86_get_dispatch) ;\t\t\t\\')
+		print ('\tCTX_INSNS ;					\\')
+		print ('\tJMP(GL_OFFSET(off))')
+		print ('')
+		print ('#elif defined(PTHREADS)')
+		print ('#  define GL_STUB(fn,off,fn_alt)\t\t\t\\')
+		print ('ALIGNTEXT16;\t\t\t\t\t\t\\')
+		print ('GLOBL_FN(GL_PREFIX(fn, fn_alt));\t\t\t\\')
+		print ('GL_PREFIX(fn, fn_alt):\t\t\t\t\t\\')
+		print ('\tMOV_L(CONTENT(GLNAME(_glapi_Dispatch)), EAX) ;\t\\')
+		print ('\tTEST_L(EAX, EAX) ;\t\t\t\t\\')
+		print ('\tJE(1f) ;\t\t\t\t\t\\')
+		print ('\tJMP(GL_OFFSET(off)) ;\t\t\t\t\\')
+		print ('1:\tCALL(_x86_get_dispatch) ;\t\t\t\\')
+		print ('\tJMP(GL_OFFSET(off))')
+		print ('#elif defined(THREADS)')
+		print ('#  define GL_STUB(fn,off,fn_alt)\t\t\t\\')
+		print ('ALIGNTEXT16;\t\t\t\t\t\t\\')
+		print ('GLOBL_FN(GL_PREFIX(fn, fn_alt));\t\t\t\\')
+		print ('GL_PREFIX(fn, fn_alt):\t\t\t\t\t\\')
+		print ('\tMOV_L(CONTENT(GLNAME(_glapi_Dispatch)), EAX) ;\t\\')
+		print ('\tTEST_L(EAX, EAX) ;\t\t\t\t\\')
+		print ('\tJE(1f) ;\t\t\t\t\t\\')
+		print ('\tJMP(GL_OFFSET(off)) ;\t\t\t\t\\')
+		print ('1:\tCALL(_glapi_get_dispatch) ;\t\t\t\\')
+		print ('\tJMP(GL_OFFSET(off))')
+		print ('#else /* Non-threaded version. */')
+		print ('#  define GL_STUB(fn,off,fn_alt)\t\t\t\\')
+		print ('ALIGNTEXT16;\t\t\t\t\t\t\\')
+		print ('GLOBL_FN(GL_PREFIX(fn, fn_alt));\t\t\t\\')
+		print ('GL_PREFIX(fn, fn_alt):\t\t\t\t\t\\')
+		print ('\tMOV_L(CONTENT(GLNAME(_glapi_Dispatch)), EAX) ;\t\\')
+		print ('\tJMP(GL_OFFSET(off))')
+		print ('#endif')
+		print ('')
+		print ('#ifdef HAVE_ALIAS')
+		print ('#  define GL_STUB_ALIAS(fn,off,fn_alt,alias,alias_alt)\t\\')
+		print ('\t.globl\tGL_PREFIX(fn, fn_alt) ;\t\t\t\\')
+		print ('\t.set\tGL_PREFIX(fn, fn_alt), GL_PREFIX(alias, alias_alt)')
+		print ('#else')
+		print ('#  define GL_STUB_ALIAS(fn,off,fn_alt,alias,alias_alt)\t\\')
+		print ('    GL_STUB(fn, off, fn_alt)')
+		print ('#endif')
+		print ('')
+		print ('SEG_TEXT')
+		print ('')
+		print ('#ifdef GLX_USE_TLS')
+		print ('')
+		print ('\tGLOBL\tGLNAME(_x86_get_dispatch)')
+		print ('\tHIDDEN(GLNAME(_x86_get_dispatch))')
+		print ('ALIGNTEXT16')
+		print ('GLNAME(_x86_get_dispatch):')
+		print ('\tcall	1f')
+		print ('1:\tpopl	%eax')
+		print ('\taddl	$_GLOBAL_OFFSET_TABLE_+[.-1b], %eax')
+		print ('\tmovl	_glapi_tls_Dispatch@GOTNTPOFF(%eax), %eax')
+		print ('\tret')
+		print ('')
+		print ('#elif defined(PTHREADS)')
+		print ('EXTERN GLNAME(_glapi_Dispatch)')
+		print ('EXTERN GLNAME(_gl_DispatchTSD)')
+		print ('EXTERN GLNAME(pthread_getspecific)')
+		print ('')
+		print ('ALIGNTEXT16')
+		print ('GLNAME(_x86_get_dispatch):')
+		print ('\tSUB_L(CONST(24), ESP)')
+		print ('\tPUSH_L(GLNAME(_gl_DispatchTSD))')
+		print ('\tCALL(GLNAME(pthread_getspecific))')
+		print ('\tADD_L(CONST(28), ESP)')
+		print ('\tRET')
+		print ('#elif defined(THREADS)')
+		print ('EXTERN GLNAME(_glapi_get_dispatch)')
+		print ('#endif')
+		print ('')
+
+		print ('#if defined( GLX_USE_TLS ) && !defined( GLX_X86_READONLY_TEXT )')
+		print ('\t\t.section\twtext, "awx", @progbits')
+		print ('#endif /* defined( GLX_USE_TLS ) */')
+
+		print ('')
+		print ('\t\tALIGNTEXT16')
+		print ('\t\tGLOBL GLNAME(gl_dispatch_functions_start)')
+		print ('\t\tHIDDEN(GLNAME(gl_dispatch_functions_start))')
+		print ('GLNAME(gl_dispatch_functions_start):')
+		print ('')
 		return
 
 
 	def printRealFooter(self):
-		print ''
-		print '\t\tGLOBL\tGLNAME(gl_dispatch_functions_end)'
-		print '\t\tHIDDEN(GLNAME(gl_dispatch_functions_end))'
-		print '\t\tALIGNTEXT16'
-		print 'GLNAME(gl_dispatch_functions_end):'
-		print ''
-		print '#if defined(GLX_USE_TLS) && defined(__linux__)'
-		print '	.section ".note.ABI-tag", "a"'
-		print '	.p2align 2'
-		print '	.long	1f - 0f   /* name length */'
-		print '	.long	3f - 2f   /* data length */'
-		print '	.long	1         /* note length */'
-		print '0:	.asciz "GNU"      /* vendor name */'
-		print '1:	.p2align 2'
-		print '2:	.long	0         /* note data: the ABI tag */'
-		print '	.long	2,4,20    /* Minimum kernel version w/TLS */'
-		print '3:	.p2align 2        /* pad out section */'
-		print '#endif /* GLX_USE_TLS */'
-		print ''
-		print '#if defined (__ELF__) && defined (__linux__)'
-		print '	.section .note.GNU-stack,"",%progbits'
-		print '#endif'
+		print ('')
+		print ('\t\tGLOBL\tGLNAME(gl_dispatch_functions_end)')
+		print ('\t\tHIDDEN(GLNAME(gl_dispatch_functions_end))')
+		print ('\t\tALIGNTEXT16')
+		print ('GLNAME(gl_dispatch_functions_end):')
+		print ('')
+		print ('#if defined(GLX_USE_TLS) && defined(__linux__)')
+		print ('	.section ".note.ABI-tag", "a"')
+		print ('	.p2align 2')
+		print ('	.long	1f - 0f   /* name length */')
+		print ('	.long	3f - 2f   /* data length */')
+		print ('	.long	1         /* note length */')
+		print ('0:	.asciz "GNU"      /* vendor name */')
+		print ('1:	.p2align 2')
+		print ('2:	.long	0         /* note data: the ABI tag */')
+		print ('	.long	2,4,20    /* Minimum kernel version w/TLS */')
+		print ('3:	.p2align 2        /* pad out section */')
+		print ('#endif /* GLX_USE_TLS */')
+		print ('')
+		print ('#if defined (__ELF__) && defined (__linux__)')
+		print ('	.section .note.GNU-stack,"",%progbits')
+		print ('#endif')
 		return
 
 
@@ -215,10 +215,10 @@
 			stack = self.get_stack_size(f)
 			alt = "%s@%u" % (name, stack)
 
-			print '\tGL_STUB(%s, _gloffset_%s, %s)' % (name, f.name, alt)
+			print ('\tGL_STUB(%s, _gloffset_%s, %s)' % (name, f.name, alt))
 
 			if not f.is_static_entry_point(f.name):
-				print '\tHIDDEN(GL_PREFIX(%s, %s))' % (name, alt)
+				print ('\tHIDDEN(GL_PREFIX(%s, %s))' % (name, alt))
 
 
 		for f in api.functionIterateByOffset():
@@ -233,16 +233,16 @@
 						text = '\tGL_STUB_ALIAS(%s, _gloffset_%s, %s, %s, %s)' % (n, f.name, alt2, name, alt)
 
 						if f.has_different_protocol(n):
-							print '#ifndef GLX_INDIRECT_RENDERING'
-							print text
-							print '#endif'
+							print ('#ifndef GLX_INDIRECT_RENDERING')
+							print (text)
+							print ('#endif')
 						else:
-							print text
+							print (text)
 
 		return
 
 def show_usage():
-	print "Usage: %s [-f input_file_name] [-m output_mode]" % sys.argv[0]
+	print ("Usage: %s [-f input_file_name] [-m output_mode]" % sys.argv[0])
 	sys.exit(1)
 
 if __name__ == '__main__':
@@ -263,7 +263,7 @@
 	if mode == "generic":
 		printer = PrintGenericStubs()
 	else:
-		print "ERROR: Invalid mode \"%s\" specified." % mode
+		print ("ERROR: Invalid mode \"%s\" specified." % mode)
 		show_usage()
 
 	api = gl_XML.parse_GL_API(file_name, glX_XML.glx_item_factory())
--- Mesa-7.8.2/src/mesa/glapi/gen/glX_doc.py.orig	2010-06-16 03:43:42.000000000 +1000
+++ Mesa-7.8.2/src/mesa/glapi/gen/glX_doc.py	2010-12-06 15:21:20.000000000 +1100
@@ -128,8 +128,8 @@
 		else:
 			s = "%u+%s" % (size, size_str)
 
-		print '            2        %-15s rendering command length' % (s)
-		print '            2        %-4u            rendering command opcode' % (f.glx_rop)
+		print ('            2        %-15s rendering command length' % (s))
+		print ('            2        %-4u            rendering command opcode' % (f.glx_rop))
 		return
 
 
@@ -140,8 +140,8 @@
 		if f.glx_vendorpriv != 0:
 			size += 1
 
-		print '            1        CARD8           opcode (X assigned)'
-		print '            1        %-4u            GLX opcode (%s)' % (f.opcode_real_value(), f.opcode_real_name())
+		print ('            1        CARD8           opcode (X assigned)')
+		print ('            1        %-4u            GLX opcode (%s)' % (f.opcode_real_value(), f.opcode_real_name()))
 
 		if size_str == "":
 			s = "%u" % (size)
@@ -150,28 +150,28 @@
 		else:
 			s = "%u+((%s)/4)" % (size, size_str)
 
-		print '            2        %-15s request length' % (s)
+		print ('            2        %-15s request length' % (s))
 
 		if f.glx_vendorpriv != 0:
-			print '            4        %-4u            vendor specific opcode' % (f.opcode_value())
+			print ('            4        %-4u            vendor specific opcode' % (f.opcode_value()))
 			
-		print '            4        GLX_CONTEXT_TAG context tag'
+		print ('            4        GLX_CONTEXT_TAG context tag')
 
 		return
 		
 
 	def print_reply(self, f):
-		print '          =>'
-		print '            1        1               reply'
-		print '            1                        unused'
-		print '            2        CARD16          sequence number'
+		print ('          =>')
+		print ('            1        1               reply')
+		print ('            1                        unused')
+		print ('            2        CARD16          sequence number')
 
 		if f.output == None:
-			print '            4        0               reply length'
+			print ('            4        0               reply length')
 		elif f.reply_always_array:
-			print '            4        m               reply length'
+			print ('            4        m               reply length')
 		else:
-			print '            4        m               reply length, m = (n == 1 ? 0 : n)'
+			print ('            4        m               reply length, m = (n == 1 ? 0 : n)')
 
 
 		output = None
@@ -182,53 +182,53 @@
 
 		unused = 24
 		if f.return_type != 'void':
-			print '            4        %-15s return value' % (f.return_type)
+			print ('            4        %-15s return value' % (f.return_type))
 			unused -= 4
 		elif output != None:
-			print '            4                        unused'
+			print ('            4                        unused')
 			unused -= 4
 
 		if output != None:
-			print '            4        CARD32          n'
+			print ('            4        CARD32          n')
 			unused -= 4
 
 		if output != None:
 			if not f.reply_always_array:
-				print ''
-				print '            if (n = 1) this follows:'
-				print ''
-				print '            4        CARD32          %s' % (output.name)
-				print '            %-2u                       unused' % (unused - 4)
-				print ''
-				print '            otherwise this follows:'
-				print ''
+				print ('')
+				print ('            if (n = 1) this follows:')
+				print ('')
+				print ('            4        CARD32          %s' % (output.name))
+				print ('            %-2u                       unused' % (unused - 4))
+				print ('')
+				print ('            otherwise this follows:')
+				print ('')
 
-			print '            %-2u                       unused' % (unused)
+			print ('            %-2u                       unused' % (unused))
 
 			[s, pad] = output.packet_size()
-			print '            %-8s %-15s %s' % (s, output.packet_type( self.type_map ), output.name)
+			print ('            %-8s %-15s %s' % (s, output.packet_type( self.type_map ), output.name))
 			if pad != None:
 				try:
 					bytes = int(s)
 					bytes = 4 - (bytes & 3)
-					print '            %-8u %-15s unused' % (bytes, "")
+					print ('            %-8u %-15s unused' % (bytes, ""))
 				except Exception,e:
-					print '            %-8s %-15s unused, %s=pad(%s)' % (pad, "", pad, s)
+					print ('            %-8s %-15s unused, %s=pad(%s)' % (pad, "", pad, s))
 		else:
-			print '            %-2u                       unused' % (unused)
+			print ('            %-2u                       unused' % (unused))
 
 
 	def print_body(self, f):
 		for p in f.parameterIterateGlxSend():
 			[s, pad] = p.packet_size()
-			print '            %-8s %-15s %s' % (s, p.packet_type( self.type_map ), p.name)
+			print ('            %-8s %-15s %s' % (s, p.packet_type( self.type_map ), p.name))
 			if pad != None:
 				try:
 					bytes = int(s)
 					bytes = 4 - (bytes & 3)
-					print '            %-8u %-15s unused' % (bytes, "")
+					print ('            %-8u %-15s unused' % (bytes, ""))
 				except Exception,e:
-					print '            %-8s %-15s unused, %s=pad(%s)' % (pad, "", pad, s)
+					print ('            %-8s %-15s unused, %s=pad(%s)' % (pad, "", pad, s))
 
 	def printBody(self, api):
 		self.type_map = {}
@@ -245,10 +245,10 @@
 
 
 			if f.glx_rop:
-				print '        %s' % (f.name)
+				print ('        %s' % (f.name))
 				self.print_render_header(f)
 			elif f.glx_sop or f.glx_vendorpriv:
-				print '        %s' % (f.name)
+				print ('        %s' % (f.name))
 				self.print_single_header(f)
 			else:
 				continue
@@ -258,7 +258,7 @@
 			if f.needs_reply():
 				self.print_reply(f)
 
-			print ''
+			print ('')
 		return
 
 
--- Mesa-7.8.2/src/mesa/glapi/gen/glX_proto_common.py.orig	2010-06-16 03:43:42.000000000 +1000
+++ Mesa-7.8.2/src/mesa/glapi/gen/glX_proto_common.py	2010-12-06 15:20:49.000000000 +1100
@@ -84,12 +84,12 @@
 
 		compsize = self.size_call(f)
 		if compsize:
-			print '    const GLuint compsize = %s;' % (compsize)
+			print ('    const GLuint compsize = %s;' % (compsize))
 
 		if bias:
-			print '    const GLuint cmdlen = %s - %u;' % (f.command_length(), bias)
+			print ('    const GLuint cmdlen = %s - %u;' % (f.command_length(), bias))
 		else:
-			print '    const GLuint cmdlen = %s;' % (f.command_length())
+			print ('    const GLuint cmdlen = %s;' % (f.command_length()))
 
-		#print ''
+		#print ('')
 		return compsize
